#ifndef G431_EXT_REFERENZ
#define G431_EXT_REFERENZ

extern uint32_t SystemCoreClock;
extern uint32_t hse_value;

#ifndef G431_GPIO_TIMER
extern void set_pin(GPIO_TypeDef* GPIOx, uint8_t number, char set);
extern void delay_us(uint32_t us);
extern void delay_ms(uint32_t ms);
extern void init_t15(void);
extern uint32_t t15_cnt;
extern uint16_t led_cnt, gps_led_cnt;
#endif

#ifndef G431_BEDIENUNG
extern uint8_t lese_taste();
extern void dekodiere_taste(uint32_t akt_tasten);
extern void G431_hauptmenue(void);
#endif

#ifndef G431_USART2
extern uint8_t  baudraten_index;
extern int16_t read_rx2_buf_count();
extern char set_baudrate2(int baud);
extern void write_tx2_buf(char c);
extern char read_rx2_buf(void);
extern void sende_string(char *s);
extern uint32_t baud_tab[7];
extern char *baud_string[7];
extern uint8_t  baudraten_index;        // default 115200
#endif

#ifndef G431_F12_MESSUNG
extern void F1_messung(uint8_t init);
extern void F2_messung(uint8_t init);
extern void wandel_Fx(char *header, double x, char zeige_periode, char *s, uint8_t stellen);    // Anzeige von Frequenz oder Periode
extern void loesche_gps_filter();

extern uint16_t   led_ein_zeit;
extern uint8_t    gps_aktiv;
extern uint16_t   gps_fil_laenge;
extern uint8_t    F1_vorteiler_aktiv, F2_vorteiler_aktiv;
extern uint8_t ausgabe_sperre, update_header;

extern volatile double  F1_taktfrequenz, F2_taktfrequenz;         // grundfrequenz
extern uint32_t         F1_messzeit, F2_messzeit,
                        F1_trigger_messzeit,
                        F1_timeout, F2_timeout,
                        F1_stellen, F2_stellen,
                        F1_faktor, F2_faktor,
                        F1_upm_divisor, F2_upm_divisor;
#endif

#ifndef G431_EE_IIC
extern uint8_t ee_write_uint8(uint16_t adr, uint8_t wert);      // ein byte schreiben
extern uint8_t ee_write_uint16(uint16_t adr, uint16_t wert);    // zwei byte schreiben
extern uint8_t ee_write_uint32(uint16_t adr, uint32_t wert);    // vier byte schreiben
extern uint8_t ee_write_double(uint16_t adr, double wert);      // acht byte schreiben

extern uint8_t ee_read_uint8(uint16_t adr, uint8_t *wert);      // ein byte lesen
extern uint8_t ee_read_uint16(uint16_t adr, uint16_t *wert);    // zwei byte lesen
extern uint8_t ee_read_uint32(uint16_t adr, uint32_t *wert);    // vier byte lesen
extern uint8_t ee_read_double(uint16_t adr, double *wert);      // acht byte lesen
extern uint8_t ee_read_n(uint16_t adr, void *ptr, uint16_t anzahl); // array lesen
extern uint8_t ee_write_n(uint16_t adr, void *ptr, uint16_t anzahl);    // array schreiben
#endif

#ifndef G431_SERIO_INPUT
extern void handle_ser_input();
extern void init_usart2(void);
#endif

#ifndef FMETER_G431
extern char version[];
extern void sende_str(char *s);
extern void berechne_F1_takt();
extern uint8_t  anzeige_funktion,
                anzeige_format,
                nur_MHz,
                F1_reg_modus,
                ser_ausgabe_kanal,
                iic_oled;

extern uint8_t   ex_ref_aktiv;           // zur einfachen Abfrage
extern uint8_t   NMI_flag;
extern int32_t   F1_offset;
extern int32_t   Fintern_offset;
extern int32_t   Fextern_offset;
extern uint32_t  abgleich_zeit;
extern uint32_t  abgleich_zeit_intern;
extern uint32_t  abgleich_zeit_extern;
extern uint32_t  vref_intern;
extern uint32_t  soll_frequenz;
extern double    F_ref;
extern void berechne_pllm_plln(uint32_t *pll_m, uint32_t *pll_n, uint32_t hse, uint32_t f_soll);
extern void aktiviere_HSE_pll(uint32_t pll_m, uint32_t pll_n, uint32_t hse);

#endif

#ifndef G431_LCD
extern uint8_t lcd_vorhanden, 
               lcd_busy;
extern uint8_t lcd_breite;
extern uint8_t lcd_kontrast;

extern uint8_t lcd_test(void);
extern uint8_t lcd_init(void);
extern void lcd_messwert_zeile1(char *s);
extern void lcd_messwert_zeile2(char *s);
extern void lcd_zeile1(char *s);
extern void lcd_zeile2(char *s);
extern void lcd_zeile3(char *s);
extern void lcd_zeile4(char *s);
extern void lcd_messwert_zeile1(char *s);    // Zeilenlnge angepasst
extern void lcd_messwert_zeile2(char *s);    // Zeilenlnge angepasst
extern void lcd_messwert_zeile3(char *s);    // Zeilenlnge angepasst
extern void lcd_messwert_zeile4(char *s);    // Zeilenlnge angepasst

extern void lcd_cmd(uint8_t cmd);
extern void lcd_zeichen(char s);
extern void lcd_string(char *s);
extern void lcd_clear();
extern void lcd_cursor_on();
extern void lcd_cursor_off();
extern void lcd_zeile_spalte(uint8_t zeile, uint8_t spalte);
extern void setze_kontrast(uint8_t wert);
extern void loesche_lcd_zeile(uint8_t zeile, uint8_t n);
extern void init_zeilen_breite(uint8_t breite);

extern void loesche_lcd_zeile1();
extern void loesche_lcd_zeile2();
extern void loesche_lcd_zeile12();
extern void loesche_lcd_zeile34();
#endif

#ifndef OLED_IIC
extern uint8_t iic_oled;
extern uint8_t oled_init();
extern void oled_out(int8_t z, int8_t mode);     // Ausgabe von Daten (mode==1) oder CMDs (mode==0)
extern void oled_string(int8_t *s);    // Zeichenkette auf LCD
extern void oled_kontrast(uint8_t k);

#endif

#ifndef G431_EE_SAVE_RECALL
extern void schreibe_kontrast(uint8_t wert);
extern void schreibe_led_zeit();
extern void schreibe_baudraten_index(uint8_t index);
extern void speicher_akt_offset(int32_t frequenz_offset);

extern void lese_baudraten_index(void);
extern void lese_ee_F1_parameter(void);
extern void schreibe_ee_F1_parameter(void);
extern void lese_ee_F2_parameter(void);
extern void schreibe_ee_F2_parameter(void);
extern void lese_ee_allgemein_parameter(void);
extern void schreibe_ee_allgemein_parameter(void);
#endif

#endif

