// PLL-Vorgaben fr HSI und HSE
#define MHZ_FAKTOR            1000000   // fuer Skalierungen
#define STD_TAKTFREQUENZ      (170 * MHZ_FAKTOR)  // @ 10 MHz
#define TURBO_TAKTFREQUENZ    (240 * MHZ_FAKTOR)
#define STD_FLASH_ZUGRIFF     FLASH_ACR_LATENCY_4WS
#define TURBO_FLASH_ZUGRIFF   FLASH_ACR_LATENCY_6WS
#define PLL_R                 2         // PLL-Ausgang immer /2
#define HSI16_PLL_N           85        // bei HSI auf SOLL_TAKTFREQUENZ
#define HSI16_PLL_M           4         // dto

enum mess_aufloesung {NORMAL = 0, HOCH_LF, HOCH_MF, HOCH_HF, OPTIMIERT};
enum pll_status {OFF, LOW, MID, HIGH, OPT}; // gewhlte Einstellung
#define F1_OPTIMIERUNG        10000     // erst ab 10 kHz
#define F1_OPTIMIERUNGS_HYS  (F1_OPTIMIERUNG/5) // 20%
#define REST_SKALIERUNG       1000      // fr optimierten PLL-Teiler
#define REST_HYS             (REST_SKALIERUNG/10) // fr low-high Vergleich 

#define HSE_VORTEILER_FAKTOR  (32 * 8)  // HSE32 + T17-Vorteiler
#define HSE_VERGLEICHSWERT    (HSE_VORTEILER_FAKTOR * (HSI_VALUE/MHZ_FAKTOR))
#define PLL_M_DIVIDEND        (HSE_VERGLEICHSWERT + HSE_VERGLEICHSWERT/50) // mit 2% Aufschlag

#define F1_REF_MIN    4000000 // ext. Fref minimal 4 MHz
#define F1_REF_MAX   48000000 // ext. Fref maximal 48 MHz


// Messintervall fr Auswertung
#define MIN_MESSZEIT 1        // 1 ms
#define MAX_MESSZEIT 25000    // 25 s
#define DEF_F1_MESSZEIT 1000  // 1 s
#define DEF_F2_MESSZEIT 666   // 0,6 s

// Bei berschreiten von Timeout "kein Signal" anzeigen
#define MIN_TIMEOUT  10       // 10 ms
#define MAX_TIMEOUT  25000    // 25 s
#define DEF_TIMEOUT  5000     // 5 s

// Bei Stellenanzahl 0 wird automatisch bewertet
#define MIN_STELLEN     5     // fr Ergebnisanzeige
#define F1_MAX_STELLEN  12    // 12 manuell einstellbar
#define F2_MAX_STELLEN  12    // 12
#define DEF_STELLEN     8     // typ. 8 Stellen anzeigen
#define F1_MIN_STELLEN  5     // bei 1 ms Messzeit ist dies das Minimum

// Skalierungsfaktor
#define MIN_FAKTOR  1
#define MAX_FAKTOR  99999
#define DEF_FAKTOR  1

#define MIN_UPM_DIVISOR  1
#define MAX_UPM_DIVISOR  99999
#define DEF_UPM_DIVISOR  1

#define DEF_OFFSET	    0
#define MAX_OFFSET	    500000        // fr jeweils 5 ppm
#define MIN_OFFSET	    -500000

#define DEF_LED_EIN_ZEIT 100
#define MIN_LED_EIN_ZEIT 1
#define MAX_LED_EIN_ZEIT 10000

#define MIN_LCD_BREITE    16          // kleinstes Format
#define MAX_LCD_BREITE    20          // max. Format
#define DEF_LCD_BREITE    16

#define DEF_LCD_KONTRAST  20
#define MIN_LCD_KONTRAST  0
#define MAX_LCD_KONTRAST  100

#define DEF_GPS_FILTER    600         // 10 Minuten
#define DEF_GPS_FIL_INT   100         // 100 s
#define MIN_GPS_FILTER    10          // 10 s
#define MAX_GPS_FILTER    1800        // max. 0,5 Stunden Mittelwert bilden
#define GPS_LED_STUFEN    30
#define GPS_TIMEOUT       1300        // 1,3 s: Referenzfrequenz zu klein / fehlt
#define GPS_TOTZEIT       5           // GPS-Signal nach Einschalten 5 Sekunden unterdruecken
#define F_OFFSET_SCHRITT  1e-11       // 0,01 ppb pro Offset-Schritt
#define PLUS_5PPM       (1.0+5e-6)    // 5 ppm Erfassungsbereich bei 0,01 ppb/Schritt
#define MINUS_5PPM      (1.0-5e-6)    // -5 ppm

#define DEF_BAUD_INDEX    4           // fr 115k2


enum mess_funktion {F_UND_P, FREQUENZ, PERIODE, DREHZAHL, MAX_FUNKTION};
// enum ser_kanal  {KEINE_AUSGABE, F1, P1, UPM1, F2, P2, UPM2, MAX_SER_KANAL};
// RS232-Ausgabe nur fr F1
enum ser_kanal  {KEINE_AUSGABE, F1, P1, UPM1, F2, MAX_SER_KANAL};

#define MAX_ANZEIGE_FORMAT      3       // wie in bedienung.c festgelegt
