#define G431_EE_SAVE_RECALL

/*
2020-12-10
Michael Nowak
http://www.mino-elektronik.de
Alle Angaben ohne Gewaehr !
*/

#include "system_G431.h"


void speicher_akt_offset(int32_t frequenz_offset)
{
  F1_offset = frequenz_offset;      // neuen ermittelten offset passend abspeichern
  if(ex_ref_aktiv) {
    Fextern_offset = F1_offset;
    ee_write_uint32(EE_ADR_Fextern_OFFSET, Fextern_offset);
  } else {  
    Fintern_offset = F1_offset;
    ee_write_uint32(EE_ADR_Fintern_OFFSET, Fintern_offset);
  }
} 

void schreibe_led_zeit()
{
  ee_write_uint16(EE_ADR_LED_EIN, led_ein_zeit);
}

void schreibe_kontrast(uint8_t kontrast)
{
  lcd_kontrast = kontrast;
  ee_write_uint8(EE_ADR_KONTRAST, kontrast);
  setze_kontrast(kontrast);
}

void lese_kontrast()
{
  ee_read_uint8(EE_ADR_KONTRAST, &lcd_kontrast);
  setze_kontrast(lcd_kontrast);
}

void schreibe_baudraten_index(uint8_t index)
{
  baudraten_index = index;
  ee_write_uint8(EE_ADR_BAUDRATE, index);
}

void lese_baudraten_index()
{
  ee_read_uint8(EE_ADR_BAUDRATE, &baudraten_index);
  set_baudrate2(baud_tab[baudraten_index]);
}

void lese_ee_F1_parameter()
{
  ee_read_double(EE_ADR_F1_TAKT, (double *)&F1_taktfrequenz);
  ee_read_uint32(EE_ADR_F1_MESSZEIT, &F1_messzeit);
//  ee_read_uint32(EE_ADR_F1_TRIGGER_MESSZEIT, &F1_trigger_messzeit);
  ee_read_uint32(EE_ADR_F1_TIMEOUT, &F1_timeout);
  ee_read_uint32(EE_ADR_F1_STELLEN, &F1_stellen);
  ee_read_uint32(EE_ADR_F1_FAKTOR, &F1_faktor);
  ee_read_uint32(EE_ADR_F1_UPM_DIV, &F1_upm_divisor);
  ee_read_uint32(EE_ADR_Fintern_OFFSET, (uint32_t *)&Fintern_offset);
  ee_read_uint32(EE_ADR_Fextern_OFFSET, (uint32_t *)&Fextern_offset);
  ee_read_uint32(EE_ADR_Fintern_ABGLEICH, &abgleich_zeit_intern);
  ee_read_uint32(EE_ADR_Fextern_ABGLEICH, &abgleich_zeit_extern);
}

void schreibe_ee_F1_parameter()
{
  ee_write_double(EE_ADR_F1_TAKT, (double)F1_taktfrequenz);
  ee_write_uint32(EE_ADR_F1_MESSZEIT, F1_messzeit);
//  ee_write_uint32(EE_ADR_F1_TRIGGER_MESSZEIT, F1_trigger_messzeit);
  ee_write_uint32(EE_ADR_F1_TIMEOUT, F1_timeout);
  ee_write_uint32(EE_ADR_F1_STELLEN, F1_stellen);
  ee_write_uint32(EE_ADR_F1_FAKTOR, F1_faktor);
  ee_write_uint32(EE_ADR_F1_UPM_DIV, F1_upm_divisor);
  ee_write_uint32(EE_ADR_Fintern_OFFSET, Fintern_offset);
  ee_write_uint32(EE_ADR_Fextern_OFFSET, Fextern_offset);
  ee_write_uint32(EE_ADR_Fintern_ABGLEICH, abgleich_zeit_intern);
  ee_write_uint32(EE_ADR_Fextern_ABGLEICH, abgleich_zeit_extern);
} 

void lese_ee_F2_parameter()
{
  ee_read_double(EE_ADR_F2_TAKT, (double *)&F2_taktfrequenz);
  ee_read_uint32(EE_ADR_F2_MESSZEIT, &F2_messzeit);
  ee_read_uint32(EE_ADR_F2_TIMEOUT, &F2_timeout);
  ee_read_uint32(EE_ADR_F2_STELLEN, &F2_stellen);
  ee_read_uint32(EE_ADR_F2_FAKTOR, &F2_faktor);
  ee_read_uint32(EE_ADR_F2_UPM_DIV, &F2_upm_divisor);
} 

void schreibe_ee_F2_parameter()
{
  ee_write_double(EE_ADR_F2_TAKT, (double)F2_taktfrequenz);
  ee_write_uint32(EE_ADR_F2_MESSZEIT, F2_messzeit);
  ee_write_uint32(EE_ADR_F2_TIMEOUT, F2_timeout);
  ee_write_uint32(EE_ADR_F2_STELLEN, F2_stellen);
  ee_write_uint32(EE_ADR_F2_FAKTOR, F2_faktor);
  ee_write_uint32(EE_ADR_F2_UPM_DIV, F1_upm_divisor);
}

void lese_ee_allgemein_parameter()
{
  lese_kontrast();
  lese_baudraten_index();
  ee_read_uint16(EE_ADR_LED_EIN, &led_ein_zeit);

  ee_read_uint8(EE_ADR_LCD_BREITE, &lcd_breite);
  ee_read_uint8(EE_ADR_GPS_AKTIV, &gps_aktiv);
  ee_read_uint8(EE_ADR_SER_AUSGABE, &ser_ausgabe_kanal);
  ee_read_uint8(EE_ADR_F1_VORTEILER, &F1_vorteiler_aktiv);
  ee_read_uint8(EE_ADR_F2_VORTEILER, &F2_vorteiler_aktiv);
  ee_read_uint8(EE_ADR_ANZEIGE_FKT, &anzeige_funktion);
  if(anzeige_funktion >= MAX_FUNKTION) anzeige_funktion = 0;
//  ee_read_uint8(EE_ADR_DAUER_EINZEL, &dauerlauf);
  ee_read_uint8(EE_ADR_ANZEIGE_FORMAT, &anzeige_format);
  ee_read_uint8(EE_ADR_NUR_MHZ, &nur_MHz);
  ee_read_uint8(EE_ADR_F1_REGRESSION, &F1_reg_modus);
}

void schreibe_ee_allgemein_parameter()
{
  schreibe_kontrast(lcd_kontrast);
  schreibe_baudraten_index(baudraten_index);
  ee_write_uint16(EE_ADR_LED_EIN, led_ein_zeit);

  ee_write_uint8(EE_ADR_LCD_BREITE, lcd_breite);
  ee_write_uint8(EE_ADR_GPS_AKTIV, gps_aktiv);
  ee_write_uint8(EE_ADR_SER_AUSGABE, ser_ausgabe_kanal);
  ee_write_uint8(EE_ADR_F1_VORTEILER, F1_vorteiler_aktiv);
  ee_write_uint8(EE_ADR_F2_VORTEILER, F2_vorteiler_aktiv);
  ee_write_uint8(EE_ADR_ANZEIGE_FKT, anzeige_funktion);
//  ee_write_uint8(EE_ADR_DAUER_EINZEL, dauerlauf);
  ee_write_uint8(EE_ADR_NUR_MHZ, nur_MHz);
  ee_write_uint8(EE_ADR_F1_REGRESSION, F1_reg_modus);
} 

